library ieee;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
library work;
use work.std_logic_arithext.all;


--datapath entity
entity ROM_constant is
   port(
      address:in std_logic_vector(5 downto 0);
      rd:in std_logic;
      oput:out std_logic_vector(255 downto 0);
      rst_n : in std_logic;
      clk : in std_logic

   );
end ROM_constant;


--signal declaration
architecture RTL of ROM_constant is
signal read:std_logic;
signal read_wire:std_logic;
signal address_reg:std_logic_vector(5 downto 0);
signal address_reg_wire:std_logic_vector(5 downto 0);
signal address_sig:std_logic_vector(5 downto 0);
signal sig_72:std_logic_vector(5 downto 0);
signal sig_73:std_logic;
signal sig_74:std_logic_vector(127 downto 0);
signal sig_75:std_logic_vector(127 downto 0);
signal sig_76:std_logic_vector(255 downto 0);
signal sig_77:std_logic_vector(255 downto 0);
signal oput_int:std_logic_vector(255 downto 0);
signal sig_0:std_logic_vector(127 downto 0);
signal sig_1:std_logic_vector(127 downto 0);
signal sig_2:std_logic_vector(127 downto 0);
signal sig_3:std_logic_vector(127 downto 0);
signal sig_4:std_logic_vector(127 downto 0);
signal sig_5:std_logic_vector(127 downto 0);
signal sig_6:std_logic_vector(127 downto 0);
signal sig_7:std_logic_vector(127 downto 0);
signal sig_8:std_logic_vector(127 downto 0);
signal sig_9:std_logic_vector(127 downto 0);
signal sig_10:std_logic_vector(127 downto 0);
signal sig_11:std_logic_vector(127 downto 0);
signal sig_12:std_logic_vector(127 downto 0);
signal sig_13:std_logic_vector(127 downto 0);
signal sig_14:std_logic_vector(127 downto 0);
signal sig_15:std_logic_vector(127 downto 0);
signal sig_16:std_logic_vector(127 downto 0);
signal sig_17:std_logic_vector(127 downto 0);
signal sig_18:std_logic_vector(127 downto 0);
signal sig_19:std_logic_vector(127 downto 0);
signal sig_20:std_logic_vector(127 downto 0);
signal sig_21:std_logic_vector(127 downto 0);
signal sig_22:std_logic_vector(127 downto 0);
signal sig_23:std_logic_vector(127 downto 0);
signal sig_24:std_logic_vector(127 downto 0);
signal sig_25:std_logic_vector(127 downto 0);
signal sig_26:std_logic_vector(127 downto 0);
signal sig_27:std_logic_vector(127 downto 0);
signal sig_28:std_logic_vector(127 downto 0);
signal sig_29:std_logic_vector(127 downto 0);
signal sig_30:std_logic_vector(127 downto 0);
signal sig_31:std_logic_vector(127 downto 0);
signal sig_32:std_logic_vector(127 downto 0);
signal sig_33:std_logic_vector(127 downto 0);
signal sig_34:std_logic_vector(127 downto 0);
signal sig_35:std_logic_vector(127 downto 0);
signal sig_36:std_logic_vector(127 downto 0);
signal sig_37:std_logic_vector(127 downto 0);
signal sig_38:std_logic_vector(127 downto 0);
signal sig_39:std_logic_vector(127 downto 0);
signal sig_40:std_logic_vector(127 downto 0);
signal sig_41:std_logic_vector(127 downto 0);
signal sig_42:std_logic_vector(127 downto 0);
signal sig_43:std_logic_vector(127 downto 0);
signal sig_44:std_logic_vector(127 downto 0);
signal sig_45:std_logic_vector(127 downto 0);
signal sig_46:std_logic_vector(127 downto 0);
signal sig_47:std_logic_vector(127 downto 0);
signal sig_48:std_logic_vector(127 downto 0);
signal sig_49:std_logic_vector(127 downto 0);
signal sig_50:std_logic_vector(127 downto 0);
signal sig_51:std_logic_vector(127 downto 0);
signal sig_52:std_logic_vector(127 downto 0);
signal sig_53:std_logic_vector(127 downto 0);
signal sig_54:std_logic_vector(127 downto 0);
signal sig_55:std_logic_vector(127 downto 0);
signal sig_56:std_logic_vector(127 downto 0);
signal sig_57:std_logic_vector(127 downto 0);
signal sig_58:std_logic_vector(127 downto 0);
signal sig_59:std_logic_vector(127 downto 0);
signal sig_60:std_logic_vector(127 downto 0);
signal sig_61:std_logic_vector(127 downto 0);
signal sig_62:std_logic_vector(127 downto 0);
signal sig_63:std_logic_vector(127 downto 0);
signal sig_64:std_logic_vector(127 downto 0);
signal sig_65:std_logic_vector(127 downto 0);
signal sig_66:std_logic_vector(127 downto 0);
signal sig_67:std_logic_vector(127 downto 0);
signal sig_68:std_logic_vector(127 downto 0);
signal sig_69:std_logic_vector(127 downto 0);
signal sig_70:std_logic_vector(127 downto 0);
signal sig_71:std_logic_vector(127 downto 0);


--lookup table declaration
Type rom_table_0 is Array (Natural range <>) of std_logic_vector(127 downto 0);
constant ROM_data0 : rom_table_0 := (B"01101010000010011110011001100111111100111011110011001001000010001011001011111011000100110110011011101010100101010111110100111110",B"10111011100010010110101111110000010110010101010110101011110011010101001010000001100000101000110101100110111001111101100110011010",B"00011000001101101110011101101011000100101101011110011100010101010001000110001010000100010011100111010010010000010111110111110101",B"00100110001100001000010110100111000000000000111110101001110000110011000101111100011011001010100010101011011001011111011110100111",
	B"00011100111010111010111111010101000110100001010101101010111010110110001010100001000111111011001110111110001011100001010011110110",B"11100101010101100100110010110101011101001111011111100000100111000111010111100010111000100100010010010010100111101001010101001001",B"01011000001000001111000011110000110101110110010011001111111100111010010101010101001010100101111001000001101010000010101110011110",B"10110001001001101111101101110100000101110011001111000101101111111100111011110110111101000011101001100010111010001110010101110000",
	B"11011011111100001101111000110010101111001010011101110010010101001011101101001111010101100010010110000001101000111011110010011001",B"11100110000100010011101111100110000101111111010001011111001111011110010100111100111111110000001110010001100110101001010011000011",B"10000000110100001101001001100000010100101100101001000101110101011001001110101011010111111011001100010000001001010000011000111001",B"01000011101011110001110001110110000100100110011100010100110111111010100101010000110000110110100001111000011111001000000110101110",
	B"10011010111011101000100110010100110100101101011101001010010111001101101101111011000111101111001010010100111011101101010111000001",B"00001011001010101010010110001100111010110011101111011011100111100001111011101111011001101011001101110110111000001100010101100101",B"01111010000101010010001111101111001111011001011100001010001110101001101100001011010011010110000100001110000000100111010010011101",B"00101100001011011011100011110111100001110110011010000101111100101100110110011010001011100000110111011011011001001100100111010101",
	B"10011101111100001000010111101011001001010100010011101011111101100010101101010000011010000110101001110001111001101110100000101000",B"11100110111001011100010000101100101100101101010001100000110010011101011011100100011110010001101000010110100000011011101100101110",B"10001111000111110101011111100100010011100001001001100010000100001111000000000111011000111111111101010111110110100010000010001010",B"10101110010011101111010001111001001011101010000101001000011000001000110011110001000101101100101100101011111111110110011011101000",
	B"10010001101001110100010011101111101111110110100010110001100100101101000001010100100110110110000010001011110110110011000110010001",B"01001011010111010010011111010011001101101000111110011100000101111101010010110010101000101011001000010110110001111110011101001110",B"00001110101000010111110010101111101110000010100001100001001100011011110110101001111000110111010101111011001101100001000010101010",B"10000100100010101111100111110101011111101011000110100110000101101110001011000011010000101100100011001110101001010010100010111000",
	B"11000000010000110101110011000011011001010100111110111000010111011101100100110011010110111010100100011010110000111101101111011110",B"10010010011101010100011111111110010111100101111001000101111000101111111010011001111100010110010100011110101000011100101111110000",B"11000001000101111010001101110111000011010011101000110100010001101001110101010000110111111010011111011011000000100000001100000000",B"10001111111100100001011110001010111000101101101111100101111010000111001011111010110001111000100110100011010010111100001000101000",
	B"10101011110100000110110001010010111011010101100011111111000010010001001000000101110100001111011000100111010101110100110010001100",B"01100011000111110100101011001011100011010011110010100100001001010011111000110000000110000100100111110001010101110101011100011101",B"10101110100010001111001000110100001011000010001100110100010001011001000010111110001000000001010011111010101101001111000101111001",B"10010011101110001001001110000101010101000110110101110001001101111001111111100100000111000011100110111100011000000010111010001011",
	B"00011101000111100000001101101010101111101110111100111111010001001000010010001100110101110110111011110110101110101010100010001001",B"10101000111001001110110111100100110001011111111001011110100010001101010011111011000110010010111000001010000010000010000111101001",B"10001110010011100011011110100011101110010111000011110000011110011010111010011101001000101010010010011001101001110001010011001000",B"01100001110011111010010000100111100100101111100100111011100111111101111000110110111010110001011000111110100101111000011100001001");
Type rom_table_1 is Array (Natural range <>) of std_logic_vector(127 downto 0);
constant ROM_data1 : rom_table_1 := (B"00111010110111101100000101110101000100100111011101010000100110011101101000101111010110010000101100000110011001110011001000101010",B"11000100001000000011010010010100111110001001101111110001001010000001011111011110101101000011001010001000011100010010001000110001",B"00101010001000000010000100100010010111111111011000110101000000000110001111011000100011100101111100011111100100010110001100011100",B"01110001001111001111010000100000000100000110000011001110100010000110101011111000010101011010100100001101011010100100111011101101",
	B"00001011011111100100100011011110100001011000000101000010011100001111110101100010111010010111011000010100110101111011010001000001",B"00100111100110101011001000100100101000101000111001000100010111010101011100011000010111100111110101111010000010011111110111000001",B"11111111011011101110000010101010011000010101011101110011101110110000011111101000011000000011010000100100110000111100111110001010",B"01101010001001100110010101100000001010001010101010001001011111101100000111101010010001100001011011001110100011111101010100010000",
	B"00011100111110010100111100100010010101100101001011000010011111110001010011101010111010010101100010101110011010101010011000010110",B"00101100100100100111101100001001001110101100100011110010001110110100011111110111000110001001101010101101101110011011110001100111",B"00000000100000111010111110110101111111111110000100000111110110101100111111001011101001111101101111100110000000011010000100101011",B"00111011111011101100111110010101011011001000010111001001011000100000100001101010111000010110111001000000111010111011000010110100",
	B"01010010000001110010010011011101100011101101010110001100100100101101001111110000111000010111010010110000110000110010000001000101",B"11010101110110001111111001111011101011001011100011011010100001100110111110000101100110101100010100100001111100111101010101110001",B"00110111101110001101010101111100000110001000010111111110010000100000011010100111111100110011100011101000001101010110100001100110",B"10111111000100111001000001010011011100011111110000111001111000001111101010000110111000010100011101110010001101001010001010010111",
	B"11011111111011011001110110111110000010110001000001101100100101000101001011001110110111011111111100111101000100111000100110010000",B"00100010001011100101010001010101100011101011011110001101010100100100010011100010000101111101000110111111110011110101000001011000",B"01010000100100111011100011111111011110010100011101010011010010100100110000100110000010100001011101100100001011110111001010110010",B"11111100011101001000000100010010011001101100110101100100000100010001001011001101000101111000000000011110110100111000101101011001",
	B"11111100000100101010000011101000001101010100001111001110110001011111100010000010001001010000101100100100010011110111100011100100",B"01110111000101001101001011001100000000111110000111100100010001011000100011001101100110010011011011011110011101000011010101111100",B"00111111011101111010011011010000010101110101000001010011111111001001001001101110111010100111111000100011011111011111001010001001",B"10101001010110100101110100010110110110011101100001111011111010011011101100110111100001001101000011000011010100011100001100101011",
	B"00011111100001011101010101100111110101111010110100010110111110011101111001101110000000001001101111001010001111111001010110110101",B"10010111110111000011101000111101010000001101110111010010000111001110111000100110000001010100001111000010100010001110110001101011",B"11010011000001101010001101100101001101110100111110101000001010001100100010110111100000001110111000011011100111010111101000110100",B"11011110101111110101010010101000100000100111010000111100101010101101000101001111001110100101010100001111110110111110011010001111",
	B"10111100000111111110011111001111011110010010000100001111010110100010001010000110111101101110001000111010001001111110111110100000",B"00110010000100011011011011000001000001000101001101000111101111101111101101111100011101111101111100111100011011001010011110111101",B"11111101010010111111011111001001000011011011000101001111101001000000000110001111110011001110011010001001110100100001001001111011",B"01111100100010110010111101111000111011101001000101001101000111110000101011110000110101000011011110100001100010011010100010100100",
	B"11111100111011000101011011001101011110010110011111101011100100001001101001000110010010111111110000100011110001110010010000110101",B"00110101101110100001010001011011101111111100010110011100001001010000100000101000001001110101010110100101110111110101001110100101",B"01110101011101100000001001110011111101110100101010010011100110001001100101011101001100101100000001010000001001111101100000010000",B"11111010111110100111011000010110111011000011110001111101101011010000000100110101100000000110110000111101100100011010001000011011");
type STATE_TYPE is (s0);
signal STATE:STATE_TYPE;
type CONTROL is (def
);
signal cmd : CONTROL;


begin
   --register updates
   dpREG: process (clk,rst_n)
      begin
         if (rst_n = '0') then
            read <= '0';
            address_reg <= (others=>'0');
         elsif clk' event and clk = '1' then
            read <= read_wire;
            address_reg <= address_reg_wire;

         end if;
      end process dpREG;


   --combinational logics
   dpCMB: process (read,address_reg,address_sig,sig_72,sig_73,sig_74,sig_75,sig_76,sig_77,oput_int
,address,rd,cmd,STATE)
      begin
         read_wire <= read;
         address_reg_wire <= address_reg;
         address_sig <= (others=>'0');
         sig_72 <= (others=>'0');
         sig_73 <= '0';
         sig_74 <= (others=>'0');
         sig_75 <= (others=>'0');
         sig_76 <= (others=>'0');
         sig_77 <= (others=>'0');
         oput_int <= (others=>'0');
         sig_0 <= "01101010000010011110011001100111111100111011110011001001000010001011001011111011000100110110011011101010100101010111110100111110";
         sig_1 <= "10111011100010010110101111110000010110010101010110101011110011010101001010000001100000101000110101100110111001111101100110011010";
         sig_2 <= "00011000001101101110011101101011000100101101011110011100010101010001000110001010000100010011100111010010010000010111110111110101";
         sig_3 <= "00100110001100001000010110100111000000000000111110101001110000110011000101111100011011001010100010101011011001011111011110100111";
         sig_4 <= "00011100111010111010111111010101000110100001010101101010111010110110001010100001000111111011001110111110001011100001010011110110";
         sig_5 <= "11100101010101100100110010110101011101001111011111100000100111000111010111100010111000100100010010010010100111101001010101001001";
         sig_6 <= "01011000001000001111000011110000110101110110010011001111111100111010010101010101001010100101111001000001101010000010101110011110";
         sig_7 <= "10110001001001101111101101110100000101110011001111000101101111111100111011110110111101000011101001100010111010001110010101110000";
         sig_8 <= "11011011111100001101111000110010101111001010011101110010010101001011101101001111010101100010010110000001101000111011110010011001";
         sig_9 <= "11100110000100010011101111100110000101111111010001011111001111011110010100111100111111110000001110010001100110101001010011000011";
         sig_10 <= "10000000110100001101001001100000010100101100101001000101110101011001001110101011010111111011001100010000001001010000011000111001";
         sig_11 <= "01000011101011110001110001110110000100100110011100010100110111111010100101010000110000110110100001111000011111001000000110101110";
         sig_12 <= "10011010111011101000100110010100110100101101011101001010010111001101101101111011000111101111001010010100111011101101010111000001";
         sig_13 <= "00001011001010101010010110001100111010110011101111011011100111100001111011101111011001101011001101110110111000001100010101100101";
         sig_14 <= "01111010000101010010001111101111001111011001011100001010001110101001101100001011010011010110000100001110000000100111010010011101";
         sig_15 <= "00101100001011011011100011110111100001110110011010000101111100101100110110011010001011100000110111011011011001001100100111010101";
         sig_16 <= "10011101111100001000010111101011001001010100010011101011111101100010101101010000011010000110101001110001111001101110100000101000";
         sig_17 <= "11100110111001011100010000101100101100101101010001100000110010011101011011100100011110010001101000010110100000011011101100101110";
         sig_18 <= "10001111000111110101011111100100010011100001001001100010000100001111000000000111011000111111111101010111110110100010000010001010";
         sig_19 <= "10101110010011101111010001111001001011101010000101001000011000001000110011110001000101101100101100101011111111110110011011101000";
         sig_20 <= "10010001101001110100010011101111101111110110100010110001100100101101000001010100100110110110000010001011110110110011000110010001";
         sig_21 <= "01001011010111010010011111010011001101101000111110011100000101111101010010110010101000101011001000010110110001111110011101001110";
         sig_22 <= "00001110101000010111110010101111101110000010100001100001001100011011110110101001111000110111010101111011001101100001000010101010";
         sig_23 <= "10000100100010101111100111110101011111101011000110100110000101101110001011000011010000101100100011001110101001010010100010111000";
         sig_24 <= "11000000010000110101110011000011011001010100111110111000010111011101100100110011010110111010100100011010110000111101101111011110";
         sig_25 <= "10010010011101010100011111111110010111100101111001000101111000101111111010011001111100010110010100011110101000011100101111110000";
         sig_26 <= "11000001000101111010001101110111000011010011101000110100010001101001110101010000110111111010011111011011000000100000001100000000";
         sig_27 <= "10001111111100100001011110001010111000101101101111100101111010000111001011111010110001111000100110100011010010111100001000101000";
         sig_28 <= "10101011110100000110110001010010111011010101100011111111000010010001001000000101110100001111011000100111010101110100110010001100";
         sig_29 <= "01100011000111110100101011001011100011010011110010100100001001010011111000110000000110000100100111110001010101110101011100011101";
         sig_30 <= "10101110100010001111001000110100001011000010001100110100010001011001000010111110001000000001010011111010101101001111000101111001";
         sig_31 <= "10010011101110001001001110000101010101000110110101110001001101111001111111100100000111000011100110111100011000000010111010001011";
         sig_32 <= "00011101000111100000001101101010101111101110111100111111010001001000010010001100110101110110111011110110101110101010100010001001";
         sig_33 <= "10101000111001001110110111100100110001011111111001011110100010001101010011111011000110010010111000001010000010000010000111101001";
         sig_34 <= "10001110010011100011011110100011101110010111000011110000011110011010111010011101001000101010010010011001101001110001010011001000";
         sig_35 <= "01100001110011111010010000100111100100101111100100111011100111111101111000110110111010110001011000111110100101111000011100001001";
         sig_36 <= "00111010110111101100000101110101000100100111011101010000100110011101101000101111010110010000101100000110011001110011001000101010";
         sig_37 <= "11000100001000000011010010010100111110001001101111110001001010000001011111011110101101000011001010001000011100010010001000110001";
         sig_38 <= "00101010001000000010000100100010010111111111011000110101000000000110001111011000100011100101111100011111100100010110001100011100";
         sig_39 <= "01110001001111001111010000100000000100000110000011001110100010000110101011111000010101011010100100001101011010100100111011101101";
         sig_40 <= "00001011011111100100100011011110100001011000000101000010011100001111110101100010111010010111011000010100110101111011010001000001";
         sig_41 <= "00100111100110101011001000100100101000101000111001000100010111010101011100011000010111100111110101111010000010011111110111000001";
         sig_42 <= "11111111011011101110000010101010011000010101011101110011101110110000011111101000011000000011010000100100110000111100111110001010";
         sig_43 <= "01101010001001100110010101100000001010001010101010001001011111101100000111101010010001100001011011001110100011111101010100010000";
         sig_44 <= "00011100111110010100111100100010010101100101001011000010011111110001010011101010111010010101100010101110011010101010011000010110";
         sig_45 <= "00101100100100100111101100001001001110101100100011110010001110110100011111110111000110001001101010101101101110011011110001100111";
         sig_46 <= "00000000100000111010111110110101111111111110000100000111110110101100111111001011101001111101101111100110000000011010000100101011";
         sig_47 <= "00111011111011101100111110010101011011001000010111001001011000100000100001101010111000010110111001000000111010111011000010110100";
         sig_48 <= "01010010000001110010010011011101100011101101010110001100100100101101001111110000111000010111010010110000110000110010000001000101";
         sig_49 <= "11010101110110001111111001111011101011001011100011011010100001100110111110000101100110101100010100100001111100111101010101110001";
         sig_50 <= "00110111101110001101010101111100000110001000010111111110010000100000011010100111111100110011100011101000001101010110100001100110";
         sig_51 <= "10111111000100111001000001010011011100011111110000111001111000001111101010000110111000010100011101110010001101001010001010010111";
         sig_52 <= "11011111111011011001110110111110000010110001000001101100100101000101001011001110110111011111111100111101000100111000100110010000";
         sig_53 <= "00100010001011100101010001010101100011101011011110001101010100100100010011100010000101111101000110111111110011110101000001011000";
         sig_54 <= "01010000100100111011100011111111011110010100011101010011010010100100110000100110000010100001011101100100001011110111001010110010";
         sig_55 <= "11111100011101001000000100010010011001101100110101100100000100010001001011001101000101111000000000011110110100111000101101011001";
         sig_56 <= "11111100000100101010000011101000001101010100001111001110110001011111100010000010001001010000101100100100010011110111100011100100";
         sig_57 <= "01110111000101001101001011001100000000111110000111100100010001011000100011001101100110010011011011011110011101000011010101111100";
         sig_58 <= "00111111011101111010011011010000010101110101000001010011111111001001001001101110111010100111111000100011011111011111001010001001";
         sig_59 <= "10101001010110100101110100010110110110011101100001111011111010011011101100110111100001001101000011000011010100011100001100101011";
         sig_60 <= "00011111100001011101010101100111110101111010110100010110111110011101111001101110000000001001101111001010001111111001010110110101";
         sig_61 <= "10010111110111000011101000111101010000001101110111010010000111001110111000100110000001010100001111000010100010001110110001101011";
         sig_62 <= "11010011000001101010001101100101001101110100111110101000001010001100100010110111100000001110111000011011100111010111101000110100";
         sig_63 <= "11011110101111110101010010101000100000100111010000111100101010101101000101001111001110100101010100001111110110111110011010001111";
         sig_64 <= "10111100000111111110011111001111011110010010000100001111010110100010001010000110111101101110001000111010001001111110111110100000";
         sig_65 <= "00110010000100011011011011000001000001000101001101000111101111101111101101111100011101111101111100111100011011001010011110111101";
         sig_66 <= "11111101010010111111011111001001000011011011000101001111101001000000000110001111110011001110011010001001110100100001001001111011";
         sig_67 <= "01111100100010110010111101111000111011101001000101001101000111110000101011110000110101000011011110100001100010011010100010100100";
         sig_68 <= "11111100111011000101011011001101011110010110011111101011100100001001101001000110010010111111110000100011110001110010010000110101";
         sig_69 <= "00110101101110100001010001011011101111111100010110011100001001010000100000101000001001110101010110100101110111110101001110100101";
         sig_70 <= "01110101011101100000001001110011111101110100101010010011100110001001100101011101001100101100000001010000001001111101100000010000";
         sig_71 <= "11111010111110100111011000010110111011000011110001111101101011010000000100110101100000000110110000111101100100011010001000011011";
         oput <= (others=>'0');



         case cmd is
            when def =>
               if (read = '1') then
                  sig_72 <= address_reg;
               else
                  sig_72 <= conv_std_logic_vector(0,6);
               end if;
               address_sig <= sig_72;
               sig_73 <=  not read;
               sig_74 <= ROM_data0(conv_integer(unsigned(address_sig)));
               sig_75 <= ROM_data1(conv_integer(unsigned(address_sig)));
               sig_76 <= sig_74 & sig_75;
               if (sig_73 = '1') then
                  sig_77 <= conv_std_logic_vector(0,256);
               else
                  sig_77 <= sig_76;
               end if;
               oput <= oput_int;
               oput_int <= sig_77;
               read_wire <= rd;
               address_reg_wire <= address;
            when others=>
         end case;
      end process dpCMB;


   --controller reg
   fsmREG: process (clk,rst_n)
      begin
         if (rst_n = '0') then
            STATE <= s0;
         elsif clk' event and clk = '1' then
            STATE <= STATE;
            case STATE is
               when s0 => 
                       STATE <= s0;
               when others=>
            end case;
         end if;
      end process fsmREG;


   --controller cmb
   fsmCMB: process (read,address_reg,address_sig,sig_72,sig_73,sig_74,sig_75,sig_76,sig_77,oput_int
,address,rd,cmd,STATE)
      begin
      cmd <= def;
      case STATE is
         when s0 => 
                 cmd <= def;
         when others=>
         end case;
   end process fsmCMB;
end RTL;
